import { RawSourceMap as SourceMap } from 'source-map';
export interface PreprocessorOptions {
    content: string;
    attributes: Record<string, string | boolean>;
    filename?: string;
}
export interface PreprocessorResult {
    code: string;
    map?: SourceMap | string;
    dependencies?: Array<string>;
}
export declare type Preprocessor = (options: PreprocessorOptions) => Promise<PreprocessorResult>;
export default function compose(preprocessors: Array<Preprocessor>): Preprocessor;
